//rot gut ncurses starter code
//dymacek nov. 2015 v0.01
//dymacek apr. 2016 v0.02

//a small class to buffer an input line
#include "Console.h"
#include "Socket.h"
#include <deque>
#include <vector>
#include <iostream>
using namespace std;

deque<string> history;


void draw(Console& console,string command){
    
    int width  = console.getWidth();
    int height = console.getHeight();
    
    console.clearScreen();
  
	int i =0;
	for(string s :history){
		console.drawString(0,i,s);
		++i;
	}
  
    console.toggleAttribute("BLINK");
    console.drawString(0,height-1,"> ");
    console.toggleAttribute("BLINK");
    console.drawString(2,height-1,command);
}

void client_main(int argc,char** argv){
	vector<Socket> sockets(1);
	sockets[0].open(argv[1],argv[2]);
	string user = argv[3];
    cout << "starting up" << endl;

	Console console;
    //start up ncurses
    console.initialize();
    //draw the screen the first time
    draw(console,"");

    string line = "";
    
    bool running = true;
    string cmd = "";
    while(running){
        
        if(console.getLine(line)){
            //there was a new line
            if(line == "quit"){
                running = false;
            }	
			sockets[0].writeString(line);
        }
        
		waitForEvent(sockets,0);
		if(sockets[0].isClosed){
			running = false;
		}else if(sockets[0].hasData){
			history.push_back(sockets[0].readString());
			if(history.size() > console.getHeight()-2){
				history.pop_front();
			}
		}

        if(cmd != line || sockets[0].hasData){
            //if the buffer changed redraw
            cmd = line;
            draw(console,cmd);
        }

    }
    console.shutdown();
}
